// https://www.infoarena.ro/problema/subsecvente2
#include <fstream>
#include <string>
#include <algorithm>
using namespace std;

ifstream fin("subsecvente.in");
ofstream fout("subsecvente.out");

struct Nod {
	Nod() : msk(0), fs(0), fd(0) 
	{}
	
	short msk;
	Nod  *fs, *fd;
};

int n, lg, j;
string a;
Nod *root, *nod;

int Lmax(Nod* nod);

int main()
{
	fin >> n;

    root = new Nod();
    root->msk = (1 << n) - 1;
    
    for (int s = 0; s < n ; ++s)    // s - indicele sirului curent
    {
		fin >> a;

        lg = a.size(); 
        nod = root;
        
        for (int i = 0; i < lg; i++)
        {
            j = min(i + 59, lg - 1);

			nod = root;
            for (int k = i; k <= j; k++)
            {	
				if (a[k] == 'a' && nod->fs == 0)   // daca nu am fiu pentru litera litera a
					nod->fs = new Nod();
					
				if (a[k] == 'b' && nod->fd == 0)   // daca nu am fiu pentru litera litera b
					nod->fd = new Nod();
			
				if (a[k] == 'a')
					nod = nod->fs;
				else
					nod = nod->fd;
					
				nod->msk |= 1 << s;     // marcam in nod ca sirul de indice s contine o secventa care se opreste in nod 
			}
        }
    }
     
    fout << Lmax(root) - 1;
    
    return 0;
}

int Lmax(Nod* nod)
{ 
    if (nod == 0 || nod->msk != (1 << n) - 1)
		return 0;
		
    int la = Lmax(nod->fs);
    int lb = Lmax(nod->fd);
    
    return max(la, lb) + 1; // maximul lungimii fiilor + o muchie
}
