// https://infoarena.ro/problema/ratina
#include<stdio.h>
#include<string.h>
#include<vector>
#include<algorithm>

using namespace std;

#define x first
#define y second

const int lg = 100002, lg2 = 100002;

int n, m, lgm, ind, mn, mx, nr, x, poz[lg], lca[2][500000], rsp[lg2], k, s, put, i;
char sir[2005];
pair<int, pair<int, int> > input[lg2];

struct trie {
	trie *fiu[26];
	vector<int> v;

	trie(){
		memset(fiu, 0, sizeof(fiu));
	}
};
trie *q = new trie;

void insert(trie * q, int ind){
	if (ind == lgm + 1){
		q -> v.push_back(i);
		return ;
	}

	int nxt = sir[ind] - 'a';
	if (!(q -> fiu[nxt]))
		q -> fiu[nxt] = new trie;

	insert(q -> fiu[nxt], ind + 1);
}
void df(trie *q, int ad)
{
	int i;

	lca[0][++ ind] = ad;

	for (i = 0; i < (int)q -> v.size(); i ++)
		poz[ q -> v[i] ] = ind;

	for (i = 0; i < 26; i ++)
		if ((q -> fiu[i]) ){
			df(q -> fiu[i], ad + 1);
			lca[0][++ ind] = ad;
		}
}

int main()
{
	freopen("ratina.in", "rt", stdin);
	freopen("ratina.out", "wt", stdout);

	scanf("%d%d\n", &n, &m);
	for (int i = 1; i <= n; ++i)
	{
		scanf("%s\n", sir + 1);
		lgm = strlen(sir + 1);
		insert(q, 1);
	}

	df(q, 0);
	
	for (int i = 1; i <= m; ++i)
	{
		scanf("%d", &nr); mn = 0x3f3f3f3f, mx = 0;

		for (int j = 1; j <= nr; ++j)
		{
			scanf("%d", &x);
			mn = min(mn, poz[x]); 
			mx = max(mx, poz[x]);
		}

		input[i].x = mx - mn + 1;
		input[i].y.x = mn;
		input[i].y.y = i;
	}

	sort(input + 1, input + m + 1);

	for (int i = 1, s = 1, j = 1; i <= m; i ++)
	{
		for (; (1 << j) <= input[i].x; j ++, s = 1 - s)
			for (k = 1; k + (1 << j) - 1 <= ind; k ++)
				lca[s][k] = min(lca[1 - s][k], lca[1 - s][k + (1 << (j - 1))]);

		put = j - 1;
		rsp[ input[i].y.y ] = min(lca[1 - s][ input[i].y.x ], lca[1 - s][ input[i].y.x + input[i].x - 1 - (1 << put) + 1]);
	}

	for (int i = 1; i <= m; i ++)
		printf("%d\n", rsp[i]);

	return 0;
}

